
JSB.newAddon = function (mainPath) {
  JSB.require('webviewController');
  var temSender;
  var MNSnipasteClass = JSB.defineClass(
    'MNSnipaste : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.appInstance = Application.sharedInstance();
        self.addonController = snipasteController.new();
        self.addonController.mainPath = mainPath;
        self.isNewWindow = false;
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        // Application.sharedInstance().showHUD(self.addonController.appearOnNewExcerpt,self.window,2)

        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          // try {
          //   self.appInstance.studyController(self.window).view.sendSubviewToBack(self.addonController.view)
            
          // } catch (error) {
          //   Application.sharedInstance().showHUD(error,self.window,2)
            
          // }
          self.addonController.view.hidden = true;
          self.addonController.notebookid = notebookid
          // self.addonController.webview.loadRequest(
          //   NSURLRequest.requestWithURL(NSURL.URLWithString(self.addonController.homePageURL))
          // );

          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'OnReceivedSnipasteNote:', 'snipasteNote');

            self.addonController.goBackButton.hidden = false
            self.addonController.goForwardButton.hidden = false
            self.addonController.view.frame = { x: 50, y: 10, width: 500, height: 500 }
            self.addonController.webview.frame = { x: 50, y: 10, width: 500, height: 500 }
            self.addonController.currentFrame = { x: 50, y: 10, width: 500, height: 500 }
          }
          if (dynamic !== undefined) {
            self.addonController.dynamic = dynamic
          }
          self.customLayoutAddonController();
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
      },

      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        // self.addonController.homePage()
        // self.watchMode = false;
        // self.textSelected = '';
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ClosePopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ProcessNewExcerpt');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            let height = studyFrame.height-10;
            let splitLine = getSplitLine()
            switch (self.addonController.customMode) {
              case "left":
                self.addonController.view.frame = { x: 40, y: 10, width: splitLine - 45, height: height }
                break;
              case "left13":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width / 3. + 40, height: height}
                break;
              case "right":
                self.addonController.view.frame = { x: splitLine + 5, y: 10, width: studyFrame.width - splitLine - 45, height: height }
                break;
              case "right13":
                self.addonController.view.frame = { x: studyFrame.width * 2 / 3. - 40, y: 10, width: studyFrame.width / 3., height: height }
                break;
              case "full":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width - 80, height: height }
                break;
              default:
                break;
            }
            self.addonController.webview.frame = self.addonController.view.bounds
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
      },

      queryAddonCommandStatus: function () {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: false
          };
        } else {
          return null;
        }
      },
      OnReceivedSnipasteNote: function (sender) {
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        // showHUD("snipaste")
        // Application.sharedInstance().showHUD(sender.userInfo.noteid,self.window,5)
        let focusNote = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        self.addonController.snipasteNote(focusNote)
      },
      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub

        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
          //  Application.sharedInstance().showHUD(sender.userInfo.winRect, self.window, 2);
        
      },
      onProcessNewExcerpt:function (sender) {
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        // Application.sharedInstance().showHUD(frameText,self.window,5
        // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
      },
      toggleAddon:function (sender) {
        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          self.addonController.addonBar = self.addonBar
        }
        if (Date.now() - self.dateNow < 500) {
          self.addonController.snipasteFromPasteboard()
          return;
        }else{
          self.dateNow = Date.now()
        }
        let docMapSplitMode = studyController().docMapSplitMode
          // Application.sharedInstance().showHUD(studyController().view.subviews, self.window, 5)
        // UIPasteboard.generalPasteboard().string = studyController().view.subviews
        let imageData = studyController().readerController.documentControllers[0].imageFromSelection()
        self.addonController.focusNoteId = undefined
        if (!imageData) {
          let focusNote
          if (docMapSplitMode===0) {
            focusNote = studyController().notebookController.focusNote
          }else{
            focusNote = studyController().readerController.documentControllers[0].focusNote
            if (!focusNote) {
              // Application.sharedInstance().showHUD("try", self.window, 5)
              focusNote = studyController().notebookController.focusNote
            }
          }
        //   imageData = studyController().readerController.documentControllers[0].imageFromFocusNote()
        // }
        // if (!imageData || docMapSplitMode===0) {
          // let focusNote = studyController().notebookController.focusNote
          if (focusNote && focusNote.excerptPic && !focusNote.noteTitle && !focusNote.comments.length) {
            imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
            self.addonController.focusNoteId = focusNote.noteId
          }else{
            imageData = undefined
          }
        }
        if (imageData) {
          let image = UIImage.imageWithData(imageData)
          let wholeFrame = studyController().view.bounds
          // let rotateImage = UIImage.imageWithCGImageScaleOrientation(image.CGImage,1.5,UIImage.orientation)
          // rotateImage.imageOrientation = 1
          // let rotateImageData = rotateImage.pngData()
          let imageSize = image.size
          let widthScale = wholeFrame.width/imageSize.width*0.5
          let heightScale = wholeFrame.height/imageSize.height*0.5
          let scale = Math.min(widthScale,heightScale)
          if (scale > 1) {
            scale = 1
          }
          // let scale = (imageSize.width < 600 || imageSize.height < 200)?1.0:0.5
          // Application.sharedInstance().showHUD("width: "+imageSize.width+" hiehgt: "+imageSize.height, self.window, 2)
          let viewFrame = self.addonController.view.frame
          self.addonController.view.frame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
          self.addonController.currentFrame = {x:viewFrame.x,y:viewFrame.y,width:imageSize.width*scale,height:imageSize.height*scale}
          // style="transform:rotate(7deg)"
          self.addonController.htmlMode = false
          self.addonController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(`data:image/png;base64,${imageData.base64Encoding()}`)))
          // self.addonController.webview.loadHTMLStringBaseURL(`
          // <img style="transform:rotate(7deg)" width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`)
          // self.addonController.webview.loadHTMLStringBaseURL(`<a href="marginnote3app://note/C08E37FD-AC36-42BB-A8AB-739296E62F23">test</a>`)
          if (self.addonController.view.hidden) {
            self.addonController.show()
          }
          // Application.sharedInstance().showHUD(123, self.window, 2)

        }else{
          let focusNote
          if (docMapSplitMode===0) {
            focusNote = studyController().notebookController.focusNote
          }else{
            focusNote = studyController().readerController.documentControllers[0].focusNote
            if (!focusNote) {
              // Application.sharedInstance().showHUD("try", self.window, 5)
              focusNote = studyController().notebookController.focusNote
            }
          }
          if (focusNote) {
            self.addonController.snipasteNote(focusNote)
          }else{
            showHUD("No image or note selected")
          }
        }
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNSnipasteClass.prototype.layoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 500 :500, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNSnipasteClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 500 : 500, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  return MNSnipasteClass;
};